#define extern static
#include <asm/io.h>
#undef extern

#include <sys/perm.h>
#include <unistd.h>
#include <vga.h>
#include <fstream>
#include <iostream>

#include "eckbox.h"

using namespace std;
int main(int argc, char** argv)
{
  ioperm(0x378,1,1);          // gives permission to use port 0x378
  
  long long int t1, t2;
  int p1,p2,href,vref,pix;
  
  p1=inb(0x378);
  t1=rdtsc();
  p2=inb(0x378);
  while(p2-p1<42)
    p2=inb(0x378);
  t2=rdtsc();
  
  pix=t2-t1;                 //sets delay time between pixels

  p1=p2;
  t1=t2;
  while(t2-t1<pix+42)
  {
    p2=inb(0x378);
    while(p2-p1<42)
      p2=inb(0x378);
    t2=rdtsc();
  }
  href=t2;                   //sets href delay time
  
  p1=p2;
  t1=t2;
  while(t2-t1<href+42)
  {
    p2=inb(0x378);
    while(p2-p1<42)
      p2=inb(0x378);
    t2=rdtsc();
  }
  vref=t2;                 //sets vref delay time
  
  cout<<"Ctrl+C out of the program when it looks best.\n";
  cout<<"Then calibration will be done.\n";
  sleep(2);

  ofstream fout;
  fout.open("/etc/eckbox.conf",ios::out);
  fout<<pix<<endl<<href<<endl<<vref<<endl<<"1";
  fout.close();

  vga_init();
  int thresh=0;
  while(!vga_getkey())
  {
    system("eckbox 0.1");
    system("rm -f /etc/eckbox.conf");
    fout.open("/etc/eckbox.conf",ios::out);
    fout<<pix<<endl<<href<<endl<<vref<<endl<<thresh;
    fout.close();
    if(thresh<256)
      thresh++;
    else
      thresh=1;
  }
  return (0);
}
